#!/bin/sh
#kidistb.tcl
#Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}
############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  :
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version $Id: tool.tcl,v 1.15 2006/06/24 04:53:30 david Exp $
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################

proc peuplelistpage {nbpage} {
global indexpage nompage
.wcorner.wtool2.listpage delete 0 end
for {set x 1} {$x<=$nbpage} {incr x} {
.wcorner.wtool2.listpage insert end $nompage([expr $x -1])
}
.wcorner.wtool2.listpage selection set $indexpage
.wcorner.wtool.labelpage configure -text $nompage($indexpage)
}

#######################################################################
proc interface {c} {
global plateforme progaide basedir Home canvw canvh bgn bgl

frame .wcorner  -width 30 -height 200
pack .wcorner -side left -anchor n -fill both
frame .wcorner.wtopcorner -width 30 -height 10
pack .wcorner.wtopcorner -side top -anchor n -fill both

#la barre d'outils
frame .wcorner.wtool -width 20 -height 80
pack .wcorner.wtool -side top -anchor n -fill both
button .wcorner.wtool.image -image [image create photo -file [file join sysdata image.gif]] -command "openimg $c image" -activebackground grey
button .wcorner.wtool.texte -image [image create photo -file [file join sysdata texte.gif]] -command "opentext $c" -activebackground grey
button .wcorner.wtool.forme -image [image create photo -file [file join sysdata forme.gif]] -command "openpoly $c" -activebackground grey
button .wcorner.wtool.poly -image [image create photo -file [file join sysdata libre.gif]] -command "tracepoly $c" -activebackground grey
pack .wcorner.wtool.image .wcorner.wtool.texte .wcorner.wtool.forme .wcorner.wtool.poly -side top -anchor n -fill x

menubutton .wcorner.wtool.bouton -direction right -image [image create photo -file [file join sysdata bouton.gif]] -menu .wcorner.wtool.bouton.b1 -relief raised -activebackground grey -background grey
menu .wcorner.wtool.bouton.b1 -tearoff 0
#.wcorner.wtool.bouton.b1 add command -label [mc {Page suivante}] -command "bouton1 $c 1"
.wcorner.wtool.bouton.b1 add command -label [mc {Page suivante}] -command "openbouton1 $c fleched 1"
#.wcorner.wtool.bouton.b1 add command -label [mc {Page precedente}] -command "bouton1 $c 2"
.wcorner.wtool.bouton.b1 add command -label [mc {Page precedente}] -command "openbouton1 $c flecheg 2"
#.wcorner.wtool.bouton.b1 add command -label [mc {Page sommaire}] -command "bouton1 $c 3"
.wcorner.wtool.bouton.b1 add command -label [mc {Page sommaire}] -command "openbouton1 $c sommaire 3"
.wcorner.wtool.bouton.b1 add command -label [mc {Autre}] -command "openimg $c bouton2"
pack .wcorner.wtool.bouton -side top -anchor n -fill x
label .wcorner.wtool.labelholder
pack .wcorner.wtool.labelholder -pady 0

button .wcorner.wtool.obj -image [image create photo -file [file join sysdata objet.gif]] -command "setnomobj $c"
pack .wcorner.wtool.obj -pady 0 -side top -fill x
label .wcorner.wtool.entobj -font {Helvetica 10} -width 3 -background #C9E4FF -borderwidth 2 -relief sunken
pack .wcorner.wtool.entobj -side top -fill x -pady 0


label .wcorner.wtool.labelholder1
pack .wcorner.wtool.labelholder1 -pady 0

button .wcorner.wtool.nompage -image [image create photo -file [file join sysdata nompage.gif]] -command "setnompage $c"
pack .wcorner.wtool.nompage -pady 0 -side top -fill x
label .wcorner.wtool.labelpage -text  [mc {Page1}] -font {Helvetica 10} -width 3 -background #C9E4FF -borderwidth 2 -relief sunken
pack .wcorner.wtool.labelpage -fill x -pady 0
button .wcorner.wtool.pageplus -image [image create photo -file [file join sysdata plus.gif]] -command "inserepage $c" -activebackground grey
button .wcorner.wtool.pagemoins -image [image create photo -file [file join sysdata moins.gif]] -command "deletepage $c" -activebackground grey
pack .wcorner.wtool.pageplus .wcorner.wtool.pagemoins -side left -pady 2 -expand 1

frame .wcorner.wtool2 -width 20 -height 50
pack .wcorner.wtool2 -side top -anchor n
listbox .wcorner.wtool2.listpage -yscrollcommand ".wcorner.wtool2.scrollpage set" -xscrollcommand ".wcorner.wtool2.scrollpagev set" -width 8 -height 5
scrollbar .wcorner.wtool2.scrollpage -command ".wcorner.wtool2.listpage yview" 
scrollbar .wcorner.wtool2.scrollpagev -orient horiz -command  ".wcorner.wtool2.listpage xview"
pack .wcorner.wtool2.scrollpage -side right -fill y -expand 1
pack .wcorner.wtool2.scrollpagev -side bottom -fill both -expand 1
pack .wcorner.wtool2.listpage -side left -fill y -expand 1
bind .wcorner.wtool2.listpage <ButtonRelease-1> "changelistpage $c %x %y"
peuplelistpage 1

frame .wmenu 
pack .wmenu -side top -padx 100

############################## la barre de menus
menu .wmenu.menu -tearoff 0
    menu .wmenu.menu.fichier -tearoff 0
    .wmenu.menu add cascade -label [mc {Fichier}] -menu .wmenu.menu.fichier
    .wmenu.menu.fichier add command -label [mc {Nouveau}] -command "nouveau $c"
    .wmenu.menu.fichier add command -label [mc {Ouvrir}] -command "charge $c"
    .wmenu.menu.fichier add command -label [mc {Enregistrer}] -command "sauve $c old"
    .wmenu.menu.fichier add command -label [mc {Enregistrer sous}] -command "sauve $c new"
    .wmenu.menu.fichier add command -label [mc {Diffuser}] -command "diffuse"
    .wmenu.menu.fichier add command -label [mc {Emporter}] -command "emporte"
    .wmenu.menu.fichier add command -label [mc {Importer}] -command "importe $c"
    .wmenu.menu.fichier add command -label [mc {Exporter svg}] -command "exporte"
    .wmenu.menu.fichier add command -label [mc {Inserer un projet}] -command "insereprojet $c"

#pour dans quelques temps :)
#    .wmenu.menu.fichier add command -label [mc {Exporter html}] -command "exportehtml"
    if {$plateforme=="unix"} {
    .wmenu.menu.fichier add command -label [mc {Imprimer}] -command "imprime $c"
    }
    .wmenu.menu.fichier add command -label [mc {Quitter}] -command "destroy ."

    menu .wmenu.menu.edition -tearoff 0
    .wmenu.menu add cascade -label [mc {Edition}] -menu .wmenu.menu.edition
    .wmenu.menu.edition add command -label [mc {Copier la page}] -command "copiepage $c"
    .wmenu.menu.edition add command -label [mc {Coller la page}] -command "collepage $c"

    menu .wmenu.menu.action -tearoff 0
    .wmenu.menu add cascade -label [mc {Action}] -menu .wmenu.menu.action
    .wmenu.menu.action add command -label [mc {Jouer}] -command "joue $c 0"
    .wmenu.menu.action add command -label [mc {Jouer Page}] -command "joue $c 1"
    .wmenu.menu.action add command -label [mc {Programmer}] -command "openevent $c"

    menu .wmenu.menu.options -tearoff 0
    .wmenu.menu add cascade -label [mc {Options}] -menu .wmenu.menu.options
    set ext .msg
    foreach i [glob [file join  $basedir msgs *$ext]] {
    set langue [string map {.msg ""} [file tail $i]]
    .wmenu.menu.options add radio -label $langue -variable langue -command "setlang $langue"
    }

    menu .wmenu.menu.aide -tearoff 0
    .wmenu.menu add cascade -label [mc {?}] -menu .wmenu.menu.aide
	if {[file exists [file join $Home lang.conf]] == 1} {
	set f [open [file join $Home lang.conf] "r"]
  	gets $f lang
  	close $f
	set fich "_index.htm"
	set fich $lang$fich
	set fichier [file join [pwd] aide $fich]
	} else {
	set fichier [file join [pwd] aide fr_index.htm]
	}
  


if {[file exists $fichier] != 1} {
set fichier [file join [pwd] aide fr_index.htm]
}
    .wmenu.menu.aide add command -label [mc {Aide}] -command "exec $progaide file:$fichier &"
    .wmenu.menu.aide add command -label [mc {A propos ...}] -command "source apropos.tcl"

. configure -menu .wmenu.menu

frame .frame -width [expr [winfo screenwidth .]] -height [expr [winfo screenheight .]]
pack .frame -side top -fill both -expand yes

wm geometry . +0+0
wm title . [mc {Kidistb - Logiciel de creation multimedia}]



set canvh [expr [winfo screenheight .] -150]
set canvw [expr [winfo screenwidth .] -100]

canvas $c -width $canvw -height $canvh 
pack $c



frame .bframe 
pack .bframe -side bottom
}

####################################################################

proc creetool {itm c} {
global canvw canvh taillefont tabpage tid msound tabobj iwish progaide basedir nompage
set ind [lindex [$c gettags cible] [lsearch -regexp [$c gettags cible] uident*]]
catch {destroy .waction}

frame .waction -width 100 -height 20
#-background gray75
pack .waction -side top -anchor w -fill both
if {$itm=="canvas"} {

menubutton .waction.couleur_f -image [image create photo -file [file join sysdata coulfond.gif]] -direction above -menu .waction.couleur_f.f1 -relief raised -activebackground grey
menu .waction.couleur_f.f1 -tearoff 0
	.waction.couleur_f.f1 add command -label [mc {Autre}] -background grey -activebackground grey -command "setcolor canvas $c"
	foreach coul {Black DarkGreen Red Green Blue Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    	.waction.couleur_f.f1 add command -label "    " -background $coul -activebackground Black -command "$c configure -background $coul"
	}
	pack .waction.couleur_f -side left -fill y
	.wcorner.wtool.entobj configure -text "canvas"
	return
} else {
button .waction.charge -image [image create photo -file [file join sysdata devant.gif]] -command "devant $c" -activebackground grey
pack .waction.charge -side left -anchor w -fill y
button .waction.sauve -image [image create photo -file [file join sysdata derriere.gif]] -command "derriere $c" -activebackground grey
pack .waction.sauve -side left -anchor w -fill y
button .waction.sup -image [image create photo -file [file join sysdata supprimer.gif]] -command "delitem $c" -activebackground grey
pack .waction.sup -side left -anchor w -fill y
.wcorner.wtool.entobj configure -text $tabobj([lindex $tid($ind) end])
}

	switch $itm {
		typetext {
		set ftrans 0
		menubutton .waction.police -image [image create photo -file [file join sysdata police.gif]] -direction above -menu .waction.police.c1 -relief raised -activebackground grey
		menu .waction.police.c1 -tearoff 0
		.waction.police.c1 add command -label [mc {Helvetica}] -command "changepolice $c Helvetica"
		.waction.police.c1 add command -label [mc {Times}] -command "changepolice $c Times"
		.waction.police.c1 add command -label [mc {Arial}] -command "changepolice $c Arial"
		pack .waction.police -side left -fill y
		menubutton .waction.taille_p -image [image create photo -file [file join sysdata taille.gif]] -direction above -menu .waction.taille_p.c2 -relief raised -activebackground grey
		menu .waction.taille_p.c2 -tearoff 0
		foreach taille {1 2 3 4 5 6} {
		.waction.taille_p.c2 add command -label [mc $taille] -command "changetaille $c $taille"
		}
		pack .waction.taille_p -side left -fill y
		menubutton .waction.couleur_t -image [image create photo -file [file join sysdata coult.gif]] -direction above -menu .waction.couleur_t.t1 -relief raised -activebackground grey
		menu .waction.couleur_t.t1 -tearoff 0
		.waction.couleur_t.t1 add command -label [mc {Autre}] -background grey -activebackground grey -command "setcolor coultext $c"
		foreach coul {Black DarkGreen Red Green Blue Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_t.t1 add command -label "    " -background $coul -activebackground Black -command "$c itemconfigure cible -fill $coul"
		}
		pack .waction.couleur_t -side left -fill y

		menubutton .waction.couleur_f -image [image create photo -file [file join sysdata coulfond.gif]] -direction above -menu .waction.couleur_f.f1 -relief raised -activebackground grey
		menu .waction.couleur_f.f1 -tearoff 0
		.waction.couleur_f.f1 add command -label [mc {Autre}] -background grey -activebackground grey -command "setcolor coulfond $c"
		foreach coul {Black DarkGreen Red Green Blue Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_f.f1 add command -label "    " -background $coul -activebackground Black -command "changefond $c $coul"
		}
		pack .waction.couleur_f -side left -fill y


		menubutton .waction.couleur_tour -image [image create photo -file [file join sysdata coultrait.gif]] -direction above -menu .waction.couleur_tour.tour -relief raised -activebackground grey
		menu .waction.couleur_tour.tour -tearoff 0
		.waction.couleur_tour.tour add command -label [mc {Autre}] -background grey -activebackground grey -command "setcolor coultour $c"
		foreach coul {Black DarkGreen Red Green Blue Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_tour.tour add command -label "    " -background $coul -activebackground Black -command "changetrait $c $coul"
		}
		pack .waction.couleur_tour -side left -fill y
		checkbutton .waction.fond_trans -variable ftrans -image [image create photo -file [file join sysdata transp.gif]] -borderwidth 4 -indicatoron 0 -activebackground grey -relief raised -command "fondtrans $c $ftrans"
		pack .waction.fond_trans -side left -fill y
		}
		typepolygon - typebouton1 {
                set ftrans2 0
		menubutton .waction.couleur_f -image [image create photo -file [file join sysdata coulfond.gif]] -direction above -menu .waction.couleur_f.f1 -relief raised -activebackground grey
		menu .waction.couleur_f.f1 -tearoff 0
		.waction.couleur_f.f1 add command -label [mc {Autre}] -background grey -activebackground grey -command "setcolor coulfond1 $c"
		foreach coul {Black DarkGreen Red Green Blue Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_f.f1 add command -label "    " -background $coul -activebackground Black -command "changefond1 $c $coul"
		}
		pack .waction.couleur_f -side left -fill y

		menubutton .waction.couleur_tour -image [image create photo -file [file join sysdata coultrait.gif]] -direction above -menu .waction.couleur_tour.tour -relief raised -activebackground grey
		menu .waction.couleur_tour.tour -tearoff 0
		.waction.couleur_tour.tour add command -label [mc {Autre}] -background grey -activebackground grey -command "setcolor coultrait1 $c"
		foreach coul {Black DarkGreen Red Green Blue Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_tour.tour add command -label "    " -background $coul -activebackground Black -command "changetrait1 $c $coul"
		}
		pack .waction.couleur_tour -side left -fill y
		checkbutton .waction.fond_trans -variable ftrans2 -image [image create photo -file [file join sysdata transp.gif]] -activebackground grey -borderwidth 4 -indicatoron 0 -relief raised -command "fondtrans1 $c $ftrans2"
		pack .waction.fond_trans -side left -fill y
		}

		typebouton2 {
		menubutton .waction.couleur_fb -image [image create photo -file [file join sysdata coult.gif]] -direction above -menu .waction.couleur_fb.f1 -relief raised -activebackground grey
		menu .waction.couleur_fb.f1 -tearoff 0
		.waction.couleur_fb.f1 add command -label [mc {Autre}] -background grey -activebackground grey -command "setcolor bouton2 $c"
		foreach coul {Black DarkGreen Red Green Blue Yellow Cyan Magenta White Brown DarkSeaGreen DarkViolet} {
    		.waction.couleur_fb.f1 add command -label "    " -background $coul -activebackground Black -command "changetextebouton2 $c $coul"
		}
		pack .waction.couleur_fb -side left -fill y
		
		menubutton .waction.page -image [image create photo -file [file join sysdata page.gif]] -direction above -menu .waction.page.c2 -relief raised -activebackground grey
		menu .waction.page.c2 -tearoff 0
		for {set i [expr [llength [array names nompage]] -1]} {$i >=0} {incr i -1} {
		.waction.page.c2 add command -label $nompage($i) -command "settabpage $i $ind"
		}

		pack .waction.page -side left -fill y
		label .waction.entpage -font {Arial 10} -width 10
		pack .waction.entpage -side left -fill y
		.waction.entpage configure -text $nompage([expr $tabpage($ind) -1])
		}
	}
if {$msound ==1} {
button .waction.forme -image [image create photo -file [file join sysdata son.gif]] -command "opensound $c" -activebackground grey
pack .waction.forme -side left -anchor w
}
}


#############################################################################
proc changelistpage {c x y} {
global nompage
set ind [.wcorner.wtool2.listpage index @$x,$y]
sauvepage $c $ind
affichenouvellepage $c
#.wcorner.wtool.labelpage configure -text [format [mc {Page %1$s}] [expr $ind +1]]
.wcorner.wtool.labelpage configure -text $nompage($ind)
}

proc inserepage {c} {
global indexpage totalpage listdata tid tabevent tabobj nompage tabpage

set ind $indexpage
relink $c $ind up
#on ajoute la page dans la liste
set listdata [linsert $listdata [expr $ind + 1] {" "}]
#on recode les scripts de tabevent pour tenir compte du dcalage
	for {set i [expr $totalpage]} {$i > [expr $ind + 1] } {incr i -1} {
	set listdata [string map "{aller Page [expr $i]} {aller Page [expr $i + 1]}" $listdata]
	}
sauvepage $c [expr $ind + 1]
affichenouvellepage $c

set tabevent(canvas) {pageenter {} pageleave {}}
incr totalpage
peuplelistpage $totalpage
}

proc deletepage {c} {
global indexpage totalpage listdata tid tabobj tabevent tabpage nompage

	if {$indexpage == 0 } {
	bell
	return}
	if {$totalpage > 1} {
	set answer [tk_messageBox -message [mc {Voulez-vous vraiment supprimer la page?}] -type yesno -title "Kidistb"]
	if {$answer == "no"} {return}

	set ind $indexpage

	relink $c $ind down
	#on recode les scripts de tabevent pour tenir compte du dcalage, on remplace les entres de la page dtruite par page?
	set listdata [lreplace $listdata [expr $ind] [expr $ind]]
	set listdata [string map "{aller Page [expr $ind + 1]} {aller Page ?}" $listdata]

	for {set i [expr $ind + 2]} {$i <= $totalpage} {incr i 1} {
	set listdata [string map "{aller Page [expr $i]} {aller Page [expr $i -1]}" $listdata]
	}

	set totalpage [expr $totalpage - 1]
     		if {$indexpage > 0} {
     		set indexpage [expr $indexpage - 1]

			$c delete all
			foreach it [lindex $listdata $indexpage] {
			eval $it}
			
		}
		peuplelistpage $totalpage
	}
	

}

proc joue {c page} {
global nomf indexpage totalpage iwish
set nomf [lindex [lindex [split $nomf /] end] 0]
if {$nomf ==""} {
bell
tk_messageBox -message [mc {Veuillez enregistrer votre travail d'abord.}] -type ok -title "Kidistb"
return
}
sauve $c old
if {$page ==0} {
exec $iwish jouer.tcl $nomf 0 &
}
if {($page==1) && ($indexpage < $totalpage)} {
exec $iwish jouer.tcl $nomf $indexpage &
}
}



proc bouton1 {c what sens} {
global canvw canvh
switch $sens {
	1 {
	createbouton1 $c $what blue black pagesuiv new
	}
	2 {
	createbouton1 $c $what blue black pageprec new
	}
	3 {
	createbouton1 $c $what blue black sommaire new
	}
}
}

proc forme {c nom} {
      if {$nom !=""} {
	createpolygon $c $nom.pol Blue Black 0 new 
	}
}

proc settabpage {it ind} {
global tabpage nompage
set tabpage($ind) [expr $it +1]
.waction.entpage configure -text $nompage([expr $tabpage($ind) -1]) 
}

proc relink {c ind sens} {

global tabpage listdata tabevent nompage totalpage indexpage
###traitement du tableau nompage
switch $sens {
		down {
			for {set it 0} {$it <[expr [llength [array names nompage]]]} {incr it} {
				if {$it > [expr $ind]} {
				set nompage([expr $it -1]) $nompage([expr $it])
				}
			}
		array unset nompage [expr $totalpage -1]
		}
		up {  
			for {set it [expr [llength [array names nompage]] -1]} {$it > 0} {incr it -1} {
				if {$it > [expr $ind]} {
				set nompage([expr $it +1]) $nompage([expr $it])
				}
			}
#######################""test pour voir si le nom n'est pas utilis########################################
		set flag 0
		set numtmp [expr $ind +1]
		set listtmp [array get nompage]
			while {$flag ==0} {
			set nomtmp "[mc {Page}]$numtmp"
				if {[lsearch $listtmp $nomtmp] != -1} {
				incr numtmp
				} else {
				set flag 1
				}
			}
		set nompage([expr $ind +1]) $nomtmp
		}

}
#traitement du tableau tabpage
################################Traitement de listdata pour tabpage
##recherche de la chaine set tabpage(uident dans listdata
##on isole la chaine tmp -> set tabpage(uidentxx) nb
##on teste nb en fonction de sens :
##sens down, nb >ind on remplace tmp1(set tabpage(uidentxx) nb) par tmp2(set tabpage(uidentxx) nb -1)
##sens up, nb >ind+1 on remplace tmp1(set tabpage(uidentxx) nb) par tmp2(set tabpage(uidentxx) nb +1)
set numpagetmp 1
foreach itlist $listdata {
	foreach it $itlist {
		if {[string first "set tabpage" $it] != -1} {
		set listmp [split $it]
		set nb [lindex $listmp 2]

			switch $sens {
				down {
					if {$nb > [expr $ind +1] } {
					set listmp [lreplace $listmp 2 2 [expr $nb -1]]
					set listdata [string map "{$it} {$listmp}" $listdata]
					}
					if {$nb == [expr $ind+1] } {
					if {$nb >$numpagetmp} {set listmp [lreplace $listmp 2 2 $numpagetmp]}
					if {$nb <=$numpagetmp} {set listmp [lreplace $listmp 2 2 [expr $numpagetmp -1]]}
					set listdata [string map "{$it} {$listmp}" $listdata]
					}

				}

				up {
					if {$nb > [expr $ind +1]} {
					set listmp [lreplace $listmp 2 2 [expr $nb +1]]
					set listdata [string map "{$it} {$listmp}" $listdata]
					}

				}
			}
		}
	}
incr numpagetmp
}
}

proc copiepage {c} {
#faudrait galement copier les scripts des pages
global tamponpage tid 
set tamponpage {}

foreach it [$c find all] {

if {[lsearch -regexp [$c gettags $it] uident*] !=-1} {
set ident [lindex [$c gettags $it] [lsearch -regexp [$c gettags $it] uident*]]
set typ [lindex [$c gettags $it] [lsearch -regexp [$c gettags $it] type*]]

set lbox [$c bbox $it]

    switch $typ {
        typetext {
	set arrfill [$c itemcget [expr [lindex $tid($ident) 0]] -fill]
	if {$arrfill ==""} {
	set arrfill \"\"
	}
	set arroutline [$c itemcget [expr [lindex $tid($ident) 0]] -outline]
	if {$arroutline ==""} {
	set arroutline \"\"
	}
	lappend tamponpage "createtexte \$c [expr [lindex $lbox 0] + int(([lindex $lbox 2] - [lindex $lbox 0])/2)] [lindex $lbox 1] \173[string map {\n \\n \" \040} [$c itemcget $it -text]]\175 $arrfill [$c itemcget $it -width] [$c itemcget $it -width] [$c itemcget $it -fill] [lindex [$c itemcget $it -font] 0] [lindex $tid($ident) 1] $arroutline new sep"

	}

	typebouton1 {
	set arrfill [$c itemcget $it -fill]
	if {$arrfill ==""} {
	set arrfill \"\"
	}
	if {[lsearch [$c gettags $it] pagesuiv] != -1} {
	lappend tamponpage "createbouton1 \$c \"[$c coords $it]\" $arrfill [$c itemcget $it -outline] pagesuiv renew"
	} elseif {[lsearch [$c gettags $it] pageprec] != -1} {
	lappend tamponpage "createbouton1 \$c \"[$c coords $it]\" $arrfill [$c itemcget $it -outline] pageprec renew"

	} elseif {[lsearch [$c gettags $it] sommaire] != -1} {
	lappend tamponpage "createbouton1 \$c \"[$c coords $it]\" $arrfill [$c itemcget $it -outline] sommaire renew"
	}
	}

	typepolygon {
	set arrfill [$c itemcget $it -fill]
	if {$arrfill ==""} {
	set arrfill \"\"
	}
	set sm [$c itemcget $it -smooth]
	if {$sm=="bezier"} {
	set sm 1
	} else {
	set sm 0}
	lappend tamponpage "createpolygon \$c \"[$c coords $it]\" $arrfill [$c itemcget $it -outline] $sm renew"
	}

	typeimage {
        lappend tamponpage "createimage \$c [lindex $tid($ident) 0] [expr [lindex $lbox 0]+ int(([lindex $lbox 2] - [lindex $lbox 0])/2)] [expr [lindex $lbox 1]+ int(([lindex $lbox 3] - [lindex $lbox 1])/2)] [lindex $tid($ident) 1] [lindex $tid($ident) 2] new"

	}
	typebouton2 {

	lappend tamponpage "createbouton2 \$c [lindex $tid($ident) 0] [expr [lindex $lbox 0]+ int(([lindex $lbox 2] - [lindex $lbox 0])/2)] [expr [lindex $lbox 1]+ int(([lindex $lbox 3] - [lindex $lbox 1])/2)] [lindex $tid($ident) 1] [lindex $tid($ident) 2] new \173[string map {\n \\n} [$c itemcget [lindex $tid($ident) 4] -text]]\175 \173[$c itemcget [lindex $tid($ident) 4] -font]\175 [$c itemcget [lindex $tid($ident) 4] -fill]"

	}

}
}

}
lappend tamponpage "\$c configure -background [$c cget -background]"
}




proc collepage {c} {
global tamponpage tid
foreach imag [image names] {
if {[string match "?imag*" $imag]} {
image delete $imag
}
}
$c delete all

foreach it $tamponpage {
eval $it
}

}


proc setcolor {type c} {
	global tid
    	set color [tk_chooseColor -title [mc {Choisir une couleur}]]

    if {$color != ""} {
	switch $type {
		canvas {$c configure -background $color}
		coultext {$c itemconfigure cible -fill $color}
		coulfond {changefond $c $color}
		coultour {changetrait $c $color}
		coulfond1 {changefond1 $c $color}
		coultrait1 {changetrait1 $c $color}
		bouton2 {changetextebouton2 $c $color}
	}
    }
}

proc diffuse {} {
global Home iwish
	
set types {    {{Fichiers kdb}            {.kdb}        }}
set ext .kdb
catch {set nom [tk_getOpenFile -filetypes $types -initialdir $Home -title "Kidistb"]}
    if {$nom != ""} {
        if  {[string match -nocase *.kdb $nom]==0} {
        set nom $nom$ext
        }

} else {

return
}
set dirnom [file rootname $nom]
catch {file delete -force [file join $Home $dirnom]}

file mkdir [file join $Home $dirnom]

set f [open [file join $dirnom go.bat] "w"]
#puts $f "start kidiplayer.tcl [file tail $nom]"
puts $f "start kidiplayer.tcl"

close $f

set f [open [file join $dirnom go.sh] "w"]
puts $f "#!/bin/sh"
puts $f "exec $iwish kidiplayer.tcl [file tail $nom]"
close $f

set f [open [file join $Home $nom] "r"]
set listd [gets $f]
close $f

#on copie tout,  l'avenir, il faudrait slectionner uniquement les objets du rpojet
catch {file attributes [file join $dirnom go.sh] -permissions rwxrwxrwx}

	file copy -force [file join $Home $nom] [file join $Home $dirnom]
	file copy -force [file join Snack.dll] [file join $Home $dirnom]
	file copy -force [file join Snack83.dll] [file join $Home $dirnom]
	file copy -force [file join kidiplayer.tcl] [file join $Home $dirnom]
	file copy -force [file join jouerutils.tcl] [file join $Home $dirnom]
	file copy -force [file join sonlinux.tcl] [file join $Home $dirnom]
	file copy -force [file join sonwindows.tcl] [file join $Home $dirnom]
	file copy -force [file join msg.tcl] [file join $Home $dirnom]
###########################################################################
file mkdir [file join $Home $dirnom images]
file mkdir [file join $Home $dirnom sons]

catch {set listtmp [glob -directory [file join $Home sons] -type f *]}
foreach fic $listtmp {
	if {[string first [string range [file tail $fic] 0 [expr [string length [file tail $fic]] -5]] $listd] != -1} {
	file copy -force [file join $fic] [file join $Home $dirnom sons [file tail $fic]]
	}
}

catch {set listtmp [glob -directory [file join $Home images] -type f *]}
foreach fic $listtmp {
	if {[string first [file tail $fic] $listd] != -1} {
	file copy -force [file join $fic] [file join $Home $dirnom images [file tail $fic]]
	}
}
##########################################################################
	file copy -force [file join lib] [file join $Home $dirnom]
	file copy -force [file join polygon] [file join $Home $dirnom]
	file copy -force [file join msgs] [file join $Home $dirnom]

tk_messageBox -message [format [mc {Le projet a ete enregistre dans le repertoire %1$s. Sous windows, il demarre en cliquant sur le fichier go.bat. Sous Linux, tapez ./go.sh ou sh ./go.sh dans une console.}] $dirnom] -type ok -title "Kidistb"

}

#############################################
proc emporte {} {
global Home iwish
	
set types {    {{Fichiers kdb}            {.kdb}        }}
set ext .kdb
catch {set nom [tk_getOpenFile -filetypes $types -initialdir $Home -title "Kidistb"]}
    if {$nom != ""} {
        if  {[string match -nocase *.kdb $nom]==0} {
        set nom $nom$ext
        }

} else {

return
}
set dirnom [file rootname $nom]
catch {file delete -force [file join $Home $dirnom]}

file mkdir [file join $Home $dirnom]



set f [open [file join $Home $nom] "r"]
set listd [gets $f]
close $f


file copy -force [file join $Home $nom] [file join $Home $dirnom]
file mkdir [file join $Home $dirnom images]
file mkdir [file join $Home $dirnom sons]

catch {set listtmp [glob -directory [file join $Home sons] -type f *]}

foreach fic $listtmp {
	if {[string first [string range [file tail $fic] 0 [expr [string length [file tail $fic]] -5]] $listd] != -1} {
	file copy -force [file join $fic] [file join $Home $dirnom sons [file tail $fic]]
	}
}

catch {set listtmp [glob -directory [file join $Home images] -type f *]}
foreach fic $listtmp {
	if {[string first [file tail $fic] $listd] != -1} {
	file copy -force [file join $fic] [file join $Home $dirnom images [file tail $fic]]
	}
}
tk_messageBox -message [format [mc {Le projet a ete enregistre dans le repertoire %1$s.}] $dirnom] -type ok -title "Kidistb"

}

################################################""
proc exportehtml {} {
    global html xindexpage
    namespace inscope can2html {
	global  Home iwish c
	#test d'export du canvas complet en fichier jpeg
	can2jpeg $c
	set types {    {{Fichiers kdb}            {.kdb}        }}
	set ext .kdb
	catch {set nom [tk_getOpenFile -filetypes $types -initialdir $Home -title "Kidistb"]}
	if {$nom != ""} {
	    if  {[string match -nocase *.kdb $nom]==0} {
		set nom $nom$ext
	    }
	    
	} else {
	    
	    return
	}
	set dirnom [file rootname $nom]
	catch {file delete -force [file join $Home $dirnom]}
	
	file mkdir [file join $Home $dirnom]
	
	set xindexpage 1
	set xtotalpage 1
	
	
	set f [open [file join $Home $nom] "r"]
	set xlistdata [gets $f]
	close $f
	set xlistdata [lreplace $xlistdata end end]
	
	set xtotalpage [expr [llength $xlistdata] -1]
	foreach listemp $xlistdata { 
	    #set listemp [lindex $xlistdata [expr $xindexpage -1]]
	    set param [string map {"\{" "" "\}" "" } [split [lindex $listemp end] -]]
	    set listemp [lreplace $listemp end end]
	    array set tabparam $param
	    set html ""
#	    lappend html pre1
#	    lappend html "<?xml version='1.0' encoding='iso-8859-1'?>"
#	    lappend html pre2 
#	    lappend html "<!DOCTYPE xml PUBLIC '-//W3C//DTD SVG 20000303 Stylable//EN' 'http://www.w3.org/TR/2000/03/WD-SVG-20000303/DTD/svg-20000303-stylable.dtd'>"
#	    lappend html pre3
#	    lappend html "<svg xml:space='preserve' width=\'$tabparam(width)\' height=\'$tabparam(height)\'>"
#	    lappend html pre4
#	    lappend html "<style type='text/css'> <!\[CDATA\[ @font-face {font-family:'Helvetica';src:url(Helvetica.cef)} @font-face {font-family:'Times';src:url(Times.cef)} @font-face {font-family:'Courier';src:url(Courier.cef)} \]\]> </style>" 
	    
	    lappend html pre5 
#	    lappend html "<rect x='0' y='0' width =\'$tabparam(width)\' height=\'$tabparam(height)\' style='stroke : $tabparam(background); fill : $tabparam(background);'/>"
	    
	    lappend html "<html>
<head>
<title>EXPORT HTML</title>
</head>
<body>"
	    foreach it $listemp {
		eval $it
	    }
	    
	    foreach it [array names tabpage] {
		set ind [lsearch $html $it]
		if {$ind != -1} {
		    set tmp [lindex $html [expr $ind +1]]
		    set html [lreplace $html [expr $ind +1] [expr $ind +1] "<a href='page$tabpage($it).html'>$tmp</a>"]
		}
		set ind [lsearch $html back$it]
		if {$ind != -1} {
		    set tmp [lindex $html [expr $ind +1]]
		    set html [lreplace $html [expr $ind +1] [expr $ind +1] "<a href='page$tabpage($it).html'>$tmp</a>"]
		}
	    }
	    
	    ############################################################
	    foreach idt [array names tabevent] {
		if {$idt != "canvas"} {
		    array set tabtmp $tabevent($idt)
		    foreach evt [array names tabtmp] {
			
			switch $evt {
			    enter{
			    }
			    
			    leave {
				
			    }
			    
			    click {
				set page 0
				set instructions [split [string map {returnx \\n} $tabtmp($evt)] "\\n"]
				
				foreach instruc $instructions {
				    if {[lindex $instruc 0] == "aller" && [lindex $instruc 1] == "Page"} {
					set page [lindex $instruc 2]
				    }
				}
				if {$page != 0} {
				    set ind [lsearch $html $idt]
				    if {$ind != -1} {
					
					set tmp [lindex $html [expr $ind +1]]
					set html [lreplace $html [expr $ind +1] [expr $ind +1] "<a href='page$page.html'>$tmp</a>"]
				    }
				    set ind [lsearch $html back$idt]
				    if {$ind != -1} {
					set tmp [lindex $html [expr $ind +1]]
					set html [lreplace $html [expr $ind +1] [expr $ind +1] "<a href='page$page.html'>$tmp</a>"]
				    }
				}
			    }
			}
		    }
		}
	    }
	    
	    
	    
	    ############################################################
	    set ext .html
	    set f [open [file join $dirnom page$xindexpage$ext] "w"]
	    foreach {pre it} $html {
		puts $f $it
	    }
	    
	    puts $f "</body></html>"
	    incr xindexpage
	    
	    
	    ############################################################""
	    close $f
	}
	#on copie tout,  l'avenir, il faudrait slectionner uniquement les objets du rpojet
	#catch {file attributes [file join $dirnom go.sh] -permissions rwxrwxrwx}
	
	file copy -force [file join $Home images] [file join $Home $dirnom]
	
	tk_messageBox -message [format [mc {Le projet a ete enregistre dans le repertoire %1$s. Le fichier de demarrage est : page1.svg. Vous devez avoir installe le plug-in Svg Reader pour pouvoir lire les fichiers generes.}] $dirnom] -type ok -title "Kidistb"
	
    }
}

################################################""
proc exporte {} {
    global xml xindexpage
    namespace inscope can2svg {
	global  Home iwish
	set types {    {{Fichiers kdb}            {.kdb}        }}
	set ext .kdb
	catch {set nom [tk_getOpenFile -filetypes $types -initialdir $Home -title "Kidistb"]}
	if {$nom != ""} {
	    if  {[string match -nocase *.kdb $nom]==0} {
		set nom $nom$ext
	    }
	    
	} else {
	    
	    return
	}
	set dirnom [file rootname $nom]
	catch {file delete -force [file join $Home $dirnom]}
	
	file mkdir [file join $Home $dirnom]
	
	set xindexpage 1
	set xtotalpage 1
	
	
	set f [open [file join $Home $nom] "r"]
	set xlistdata [gets $f]
	close $f
	set xlistdata [lreplace $xlistdata end end]
	
	set xtotalpage [expr [llength $xlistdata] -1]
	foreach listemp $xlistdata { 
	    #set listemp [lindex $xlistdata [expr $xindexpage -1]]
	    set param [string map {"\{" "" "\}" "" } [split [lindex $listemp end] -]]
	    set listemp [lreplace $listemp end end]
	    array set tabparam $param
	    set xml ""
	    lappend xml pre1
	    lappend xml "<?xml version='1.0' encoding='iso-8859-1'?>"
	    lappend xml pre2 
	    lappend xml "<!DOCTYPE svg PUBLIC '-//W3C//DTD SVG 20000303 Stylable//EN' 'http://www.w3.org/TR/2000/03/WD-SVG-20000303/DTD/svg-20000303-stylable.dtd'>"
	    lappend xml pre3
	    lappend xml "<svg xml:space='preserve' width=\'$tabparam(width)\' height=\'$tabparam(height)\'>"
	    lappend xml pre4
	    lappend xml "<style type='text/css'> <!\[CDATA\[ @font-face {font-family:'Helvetica';src:url(Helvetica.cef)} @font-face {font-family:'Times';src:url(Times.cef)} @font-face {font-family:'Courier';src:url(Courier.cef)} \]\]> </style>" 
	    
	    lappend xml pre5 
	    lappend xml "<rect x='0' y='0' width =\'$tabparam(width)\' height=\'$tabparam(height)\' style='stroke : $tabparam(background); fill : $tabparam(background);'/>"
	    
	    foreach it $listemp {
		eval $it
	    }
	    
	    foreach it [array names tabpage] {
		set ind [lsearch $xml $it]
		if {$ind != -1} {
		    set tmp [lindex $xml [expr $ind +1]]
		    set xml [lreplace $xml [expr $ind +1] [expr $ind +1] "<a xlink:href='page$tabpage($it).svg'>$tmp</a>"]
		}
		set ind [lsearch $xml back$it]
		if {$ind != -1} {
		    set tmp [lindex $xml [expr $ind +1]]
		    set xml [lreplace $xml [expr $ind +1] [expr $ind +1] "<a xlink:href='page$tabpage($it).svg'>$tmp</a>"]
		}
	    }
	    
	    ############################################################
	    foreach idt [array names tabevent] {
		if {$idt != "canvas"} {
		    array set tabtmp $tabevent($idt)
		    foreach evt [array names tabtmp] {
			
			switch $evt {
			    enter{
			    }
			    
			    leave {
				
			    }
			    
			    click {
				set page 0
				set instructions [split [string map {returnx \\n} $tabtmp($evt)] "\\n"]
				
				foreach instruc $instructions {
				    if {[lindex $instruc 0] == "aller" && [lindex $instruc 1] == "Page"} {
					set page [lindex $instruc 2]
				    }
				}
				if {$page != 0} {
				    set ind [lsearch $xml $idt]
				    if {$ind != -1} {
					
					set tmp [lindex $xml [expr $ind +1]]
					set xml [lreplace $xml [expr $ind +1] [expr $ind +1] "<a xlink:href='page$page.svg'>$tmp</a>"]
				    }
				    set ind [lsearch $xml back$idt]
				    if {$ind != -1} {
					set tmp [lindex $xml [expr $ind +1]]
					set xml [lreplace $xml [expr $ind +1] [expr $ind +1] "<a xlink:href='page$page.svg'>$tmp</a>"]
				    }
				}
			    }
			}
		    }
		}
	    }
	    
	    
	    
	    ############################################################
	    set ext .svg
	    set f [open [file join $dirnom page$xindexpage$ext] "w"]
	    foreach {pre it} $xml {
		puts $f $it
	    }
	    
	    puts $f "</svg>"
	    incr xindexpage
	    
	    
	    ############################################################""
	    close $f
	}
	#on copie tout,  l'avenir, il faudrait slectionner uniquement les objets du rpojet
	#catch {file attributes [file join $dirnom go.sh] -permissions rwxrwxrwx}
	
	file copy -force [file join $Home images] [file join $Home $dirnom]
	
	tk_messageBox -message [format [mc {Le projet a ete enregistre dans le repertoire %1$s. Le fichier de dmarrage est : page1.svg. Vous devez avoir install le plug-in Svg Reader pour pouvoir lire les fichiers gnrs. }] $dirnom] -type ok -title "Kidistb"
	
    }
}


##############################################
proc setnompage {c} {
catch {destroy .nomobj}
toplevel .nomobj -background grey -width 300 -height 100
wm geometry .nomobj +50+50
wm  title .nomobj [mc {Choisir une page}]

frame .nomobj.frame -background grey -width 300 -height 100
pack .nomobj.frame -side top
label .nomobj.frame.labobj -font {Helvetica 10} -text [mc {Nouveau nom :}] -background grey
pack .nomobj.frame.labobj -side top 
entry .nomobj.frame.entobj -font {Helvetica 10} -width 15
pack .nomobj.frame.entobj -side top -padx 60
button .nomobj.frame.ok -background grey -text [mc {Ok}] -command "verifnompage $c"
pack .nomobj.frame.ok -side top -pady 10
}

proc verifnompage {c} {
global nompage indexpage totalpage
set nompag [string map {\{ \040 \} \040 \[ \040 \] \040 \" \040 \\" \040 ' \040 , \040 ; \040 : \040 ( \040 ) \040 - \040} [.nomobj.frame.entobj get]]
set nompag [string map {\040 _} $nompag]

	foreach item [array names nompage] {
		if {$nompag == $nompage($item)} {
		tk_messageBox -message [mc {Ce nom existe deja.}] -type ok -icon info -title "Kidistb"
		catch {destroy .nomobj}
		return
		}
	}
if {$nompag != "" } {
set nompage($indexpage) $nompag
.wcorner.wtool.labelpage configure -text $nompage($indexpage)
peuplelistpage $totalpage
}
catch {destroy .nomobj}
}


proc setnomobj {c} {
global tid tabobj
#return si nom = canvas
if {[.wcorner.wtool.entobj cget -text] == "canvas"} {
return
}
catch {destroy .nomobj}
toplevel .nomobj -background grey -width 300 -height 100
wm geometry .nomobj +50+50
wm  title .nomobj [mc {Choisir un nom}]

frame .nomobj.frame -background grey -width 300 -height 100
pack .nomobj.frame -side top
label .nomobj.frame.labobj -font {Helvetica 10} -text [mc {Nouveau nom :}] -background grey
pack .nomobj.frame.labobj -side top 
entry .nomobj.frame.entobj -font {Helvetica 10} -width 15
pack .nomobj.frame.entobj -side top -padx 60
button .nomobj.frame.ok -background grey -text [mc {Ok}] -command "verifnomobj $c"
pack .nomobj.frame.ok -side top -pady 10
}

proc verifnomobj {c} {
global tabobj tabevent
set ind [lindex [$c gettags cible] [lsearch -regexp [$c gettags cible] uident*]]
set nomobjet [string map {\{ \040 \} \040 \[ \040 \] \040 \" \040 \\" \040 ' \040 , \040 ; \040 : \040 ( \040 ) \040 - \040} [.nomobj.frame.entobj get]]
set nomobjet [string map {\040 _} $nomobjet]
foreach item [array names tabobj] {
if {$nomobjet == $tabobj($item)} {
tk_messageBox -message [mc {Ce nom existe deja.}] -type ok -icon info -title "Kidistb"
catch {destroy .nomobj}
return
}
}
# on modifie tabevent pour prendre en compte le nouveau nom de l'objet
if {$ind !="" && $ind !=-1 && $nomobjet != "" } {
foreach item [array names tabevent] {
set tabevent($item) [string map "{$tabobj($ind)} {$nomobjet}" $tabevent($item)]
}
set tabobj($ind) $nomobjet
.wcorner.wtool.entobj configure -text $tabobj($ind)
}
catch {destroy .nomobj}
}

proc setlang {lang} {
global env plateforme Home c
set env(LANG) $lang
set f [open [file join $Home lang.conf] "w"]
puts $f $lang
close $f

::msgcat::mclocale $lang
::msgcat::mcload [file join [file dirname [info script]] msgs]
tk_messageBox -message [mc {Les changements prendront effets au redemarrage de l'application.}] -type ok -title "Kidistb"
}

#########################################################################
proc importe {c} {
global Home tabpage listdata totalpage indexlibre indexpage tid tabevent tabobj
set ext ".kdb"
set nom ""
catch {set nom [tk_chooseDirectory -mustexist true -initialdir $Home -title "Kidistb"]}
    if {$nom == ""} {return}
        if  {[file exists [file join $nom [file tail $nom]$ext]] != 1} {
        	tk_messageBox -message [mc {Le dossier ne comporte pas de projet.Veuillez d'abord enregistrer un projet avec la commande diffuser pour pouvoir l'importer.}] -type ok -title "Kidistb"
		return
        }

set answer [tk_messageBox -message [mc {Les fichiers de media vont etre importes. Si certains portent le meme nom, ils ne seront pas recopies.}] -type yesno -title "Kidistb"]
if {$answer == "no"} {return}
set listtmp1 ""
catch {set listtmp1 [glob -directory [file join $nom images] -type f *]}
foreach item $listtmp1 {
if {![file exists [file join $Home images [file tail $item]]]} {
file copy -force [file join $nom images [file tail $item]] [file join $Home images]
}
}
set listtmp1 ""

catch {set listtmp1 [glob -directory [file join $nom sons] -type f *]}
foreach item $listtmp1 {
if {![file exists [file join $Home sons [file tail $item]]]} {
file copy -force [file join $nom sons [file tail $item]] [file join $Home sons]
}
}


set f [open [file join $Home $nom [file tail $nom]$ext ] "r"]
set listdata [gets $f]
close $f
set answer [tk_messageBox -message [mc {Le projet a ete importe.}] -type ok -title "Kidistb"]

}
###########################################################################
proc insereprojet {c} {
global Home tabpage listdata totalpage indexlibre indexpage tid tabevent tabobj nompage
sauvepage $c $indexpage
########################""""
set ext ".kdb"
set nom ""
catch {set nom [tk_chooseDirectory -mustexist true -initialdir $Home -title "Kidistb"]}
    if {$nom == ""} {return}
        if  {[file exists [file join $nom [file tail $nom]$ext]] != 1} {
        	tk_messageBox -message [mc {Le dossier ne comporte pas de projet.Veuillez d'abord enregistrer un projet avec la commande diffuser pour pouvoir l'importer.}] -type ok -title "Kidistb"
		return
        }

set answer [tk_messageBox -message [mc {Les fichiers de media vont etre importes. Si certains portent le meme nom, ils ne seront pas recopies.}] -type yesno -title "Kidistb"]
if {$answer == "no"} {return}
set listtmp1 ""
catch {set listtmp1 [glob -directory [file join $nom images] -type f *]}
foreach item $listtmp1 {
if {![file exists [file join $Home images [file tail $item]]]} {
file copy -force [file join $nom images [file tail $item]] [file join $Home images]
}
}
set listtmp1 ""

catch {set listtmp1 [glob -directory [file join $nom sons] -type f *]}
foreach item $listtmp1 {
if {![file exists [file join $Home sons [file tail $item]]]} {
file copy -force [file join $nom sons [file tail $item]] [file join $Home sons]
}
}


set f [open [file join $Home $nom [file tail $nom]$ext ] "r"]
set listdataimport [gets $f]
close $f

set totalpageimport [expr [llength $listdataimport] -1]

for {set npage [expr [llength [array names nompage]] -1]} {$npage >=0} {incr npage -1} {
set nompage([expr $npage + $totalpageimport]) $nompage($npage)
}

for {set npage 0} {$npage < $totalpageimport} {incr npage} {
set nompage($npage) "[mc {Page}][expr $npage +1]"
}

set tmp [lindex $listdataimport [expr [llength $listdataimport] -1]]
set tmp [string map {indexlibre indexlibre2} $tmp]
eval $tmp

if {$indexlibre <$indexlibre2} {set indexlibre $indexlibre2}
#################################################################################""
#########relink

foreach it [array names tabpage] {
set temp1 "set tabpage($it) $tabpage($it)"
set temp2 "set tabpage($it) [expr $tabpage($it) +  $totalpageimport]"
set tabpage($it) [expr $tabpage($it) + $totalpageimport]
set listdata [string map "{$temp1} {$temp2}" $listdata]
}
for {set i [expr $totalpage]} {$i > 0 } {incr i -1} {
set listdata [string map "{aller Page [expr $i]} {aller Page [expr $i + $totalpageimport]}" $listdata]
}
###########################on ajoute les pages dans la liste
for {set ii [expr $totalpageimport]} {$ii > 0 } {incr ii -1} {
set listdata [linsert $listdata 0 [lindex $listdataimport [expr $ii -1]]]
incr totalpage
}
$c delete all
catch {unset tid}
catch {unset tabobj}
catch {unset tabevent}
set tabevent(canvas) {pageenter {} pageleave {}}
set indexpage 0
peuplelistpage $totalpage

foreach it [lindex $listdata 0] {
eval $it
}


set canvw [$c cget -width]
set canvh [$c cget -height]
$c dtag all cible
$c delete enveloppe
$c focus ""

#peuplelistpage $totalpage
}

proc quitte {c} {
set answer [tk_messageBox -message [mc {Enregistrer les modifications?}] -type yesno -icon info -title "Kidistb"]
if {$answer == "yes"} {
sauve $c old
}
destroy .
}

interface $c
